diff --git a/src/db.c b/src/db.c
index 53ec1a2c27..44b9964968 100644
--- a/src/db.c
+++ b/src/db.c
@@ -290,22 +290,22 @@ static const struct col_type_map wi_cols_map[] =
   };
 
 /* Sort clauses */
-/* Keep in sync with enum sort_type */
+/* Keep in sync with enum sort_type and indices */
 static const char *sort_clause[] =
   {
     "",
-    "ORDER BY f.title_sort ASC",
-    "ORDER BY f.album_sort ASC, f.disc ASC, f.track ASC",
-    "ORDER BY f.album_artist_sort ASC, f.album_sort ASC, f.disc ASC, f.track ASC",
-    "ORDER BY f.type ASC, f.parent_id ASC, f.special_id ASC, f.title ASC",
-    "ORDER BY f.year ASC",
-    "ORDER BY f.genre ASC",
-    "ORDER BY f.composer_sort ASC",
-    "ORDER BY f.disc ASC",
-    "ORDER BY f.track ASC",
-    "ORDER BY f.virtual_path ASC",
-    "ORDER BY pos ASC",
-    "ORDER BY shuffle_pos ASC",
+    "ORDER BY f.title_sort",
+    "ORDER BY f.album_sort, f.album, f.disc, f.track",
+    "ORDER BY f.album_artist_sort, f.album_artist",
+    "ORDER BY f.type, f.parent_id, f.special_id, f.title",
+    "ORDER BY f.year",
+    "ORDER BY f.genre",
+    "ORDER BY f.composer_sort",
+    "ORDER BY f.disc",
+    "ORDER BY f.track",
+    "ORDER BY f.virtual_path",
+    "ORDER BY pos",
+    "ORDER BY shuffle_pos",
   };
 
 /* Shuffle RNG state */
@@ -1329,7 +1329,7 @@ db_build_query_group_dirs(struct query_params *qp)
 }
 
 static char *
-db_build_query_browse(struct query_params *qp, const char *field, const char *group_field)
+db_build_query_browse(struct query_params *qp, const char *field, const char *sort_field)
 {
   struct query_clause *qc;
   char *count;
@@ -1339,8 +1339,8 @@ db_build_query_browse(struct query_params *qp, const char *field, const char *gr
   if (!qc)
     return NULL;
 
-  count = sqlite3_mprintf("SELECT COUNT(DISTINCT f.%s) FROM files f %s AND f.%s != '';", field, qc->where, field);
-  query = sqlite3_mprintf("SELECT f.%s, f.%s FROM files f %s AND f.%s != '' GROUP BY f.%s %s %s;", field, group_field, qc->where, field, group_field, qc->order, qc->index);
+  count = sqlite3_mprintf("SELECT COUNT(*) FROM (SELECT DISTINCT f.%s, f.%s FROM files f %s);", field, sort_field, qc->where);
+  query = sqlite3_mprintf("SELECT DISTINCT f.%s, f.%s FROM files f %s %s %s;", field, sort_field, qc->where, qc->order, qc->index);
 
   db_free_query_clause(qc);
 
diff --git a/src/db_init.c b/src/db_init.c
index f073af2d9b..9bb6d8c99e 100644
--- a/src/db_init.c
+++ b/src/db_init.c
@@ -302,7 +302,7 @@ static const struct db_init_query db_init_table_queries[] =
 
 /* Used by Q_GROUP_ALBUMS */
 #define I_SONGALBUMID				\
-  "CREATE INDEX IF NOT EXISTS idx_sali ON files(songalbumid, disabled, media_kind, album_sort, disc, track);"
+  "CREATE INDEX IF NOT EXISTS idx_sali ON files(songalbumid, disabled, media_kind, album_sort, album, disc, track);"
 
 /* Used by Q_GROUP_ARTISTS */
 #define I_STATEMKINDSARI				\
@@ -311,26 +311,25 @@ static const struct db_init_query db_init_table_queries[] =
 #define I_STATEMKINDSALI				\
   "CREATE INDEX IF NOT EXISTS idx_state_mkind_sali ON files(disabled, media_kind, songalbumid);"
 
-#define I_ARTIST				\
-  "CREATE INDEX IF NOT EXISTS idx_artist ON files(artist, artist_sort);"
+/* Used by Q_BROWSE_ALBUM */
+#define I_ALBUM					\
+  "CREATE INDEX IF NOT EXISTS idx_album ON files(disabled, album_sort, album, disc, track);"
 
+/* Used by Q_BROWSE_ARTIST */
 #define I_ALBUMARTIST				\
-  "CREATE INDEX IF NOT EXISTS idx_albumartist ON files(album_artist, album_artist_sort);"
+  "CREATE INDEX IF NOT EXISTS idx_albumartist ON files(disabled, album_artist_sort, album_artist);"
 
 /* Used by Q_BROWSE_COMPOSERS */
 #define I_COMPOSER				\
-  "CREATE INDEX IF NOT EXISTS idx_composer ON files(disabled, media_kind, composer_sort);"
+  "CREATE INDEX IF NOT EXISTS idx_composer ON files(disabled, composer_sort, composer, media_kind);"
 
 /* Used by Q_BROWSE_GENRES */
 #define I_GENRE					\
-  "CREATE INDEX IF NOT EXISTS idx_genre ON files(disabled, media_kind, genre);"
+  "CREATE INDEX IF NOT EXISTS idx_genre ON files(disabled, genre, genre, media_kind);"
 
 /* Used by Q_PLITEMS for smart playlists */
 #define I_TITLE					\
-  "CREATE INDEX IF NOT EXISTS idx_title ON files(disabled, media_kind, title_sort);"
-
-#define I_ALBUM					\
-  "CREATE INDEX IF NOT EXISTS idx_album ON files(album, album_sort);"
+  "CREATE INDEX IF NOT EXISTS idx_title ON files(disabled, title_sort, media_kind);"
 
 #define I_FILELIST					\
   "CREATE INDEX IF NOT EXISTS idx_filelist ON files(disabled, virtual_path, time_modified);"
@@ -380,7 +379,6 @@ static const struct db_init_query db_init_index_queries[] =
     { I_STATEMKINDSARI, "create state/mkind/sari index" },
     { I_STATEMKINDSALI, "create state/mkind/sali index" },
 
-    { I_ARTIST,    "create artist index" },
     { I_ALBUMARTIST, "create album_artist index" },
     { I_COMPOSER,  "create composer index" },
     { I_GENRE,     "create genre index" },
diff --git a/src/db_init.h b/src/db_init.h
index b636bbca25..0c37f83a82 100644
--- a/src/db_init.h
+++ b/src/db_init.h
@@ -26,7 +26,7 @@
  * is a major upgrade. In other words minor version upgrades permit downgrading
  * forked-daapd after the database was upgraded. */
 #define SCHEMA_VERSION_MAJOR 19
-#define SCHEMA_VERSION_MINOR 06
+#define SCHEMA_VERSION_MINOR 07
 
 int
 db_init_indices(sqlite3 *hdl);
diff --git a/src/db_upgrade.c b/src/db_upgrade.c
index 2ef4680663..857d59c7b9 100644
--- a/src/db_upgrade.c
+++ b/src/db_upgrade.c
@@ -1574,8 +1574,6 @@ static const struct db_upgrade_query db_upgrade_v1905_queries[] =
   };
 
 
-/* Upgrade from schema v19.05 to v20.00 */
-
 #define U_V1906_DROP_TABLE_QUEUE					\
   "DROP TABLE queue;"
 
@@ -1626,6 +1624,16 @@ static const struct db_upgrade_query db_upgrade_V1906_queries[] =
   };
 
 
+#define U_V1907_SCVER_MINOR			\
+  "UPDATE admin SET value = '07' WHERE key = 'schema_version_minor';"
+
+// Purpose of this upgrade is to reset the indeces
+static const struct db_upgrade_query db_upgrade_V1907_queries[] =
+  {
+    { U_V1907_SCVER_MINOR,    "set schema_version_minor to 07" },
+  };
+
+
 int
 db_upgrade(sqlite3 *hdl, int db_ver)
 {
@@ -1778,6 +1786,13 @@ db_upgrade(sqlite3 *hdl, int db_ver)
       if (ret < 0)
 	return -1;
 
+      /* FALLTHROUGH */
+
+    case 1906:
+      ret = db_generic_upgrade(hdl, db_upgrade_V1907_queries, sizeof(db_upgrade_V1907_queries) / sizeof(db_upgrade_V1907_queries[0]));
+      if (ret < 0)
+	return -1;
+
       break;
 
     default:
